<template>
  <q-dialog v-model="changePasswordModal">
    <q-card class="q-pa-md" style="width: 400px; max-width: 80vw;">
      <q-form class="q-gutter-sm" label-width="120px" @submit.prevent="onChangePassword" autocomplete="off">
        <q-card-section>
          <div class="q-gutter-sm">
            <div>
              <label class="q-mb-sm">
                ผู้ใช้งาน
                <q-input :value="username" type="text" readonly
                         outlined dense/>
              </label>
            </div>
            <div>
              <label>
                รหัสผ่าน
                <q-input v-model="$v.changePasswordForm.new_password.$model" type="password"
                         :autocomplete="'off'"
                         :error="$v.changePasswordForm.retype_new_password.$error"
                         error-message="กรุณากรอกรหัสผ่านอย่างน้อย 8 ตัว"
                         outlined dense/>
              </label>
            </div>
            <div>
              <label>
                ยืนยันรหัสผ่าน
                <q-input v-model="$v.changePasswordForm.retype_new_password.$model" type="password"
                         :autocomplete="'off'"
                         :error="$v.changePasswordForm.retype_new_password.$error"
                         error-message="กรุณากรอกผ่านให้ตรงกัน"
                         outlined dense/>
              </label>
            </div>
          </div>
        </q-card-section>
        <q-separator/>
        <q-card-actions align="right">
          <q-btn v-close-popup flat color="negative" label="ปิด"/>
          <q-btn push type="submit" color="primary" label="เปลี่ยนรหัสผ่าน"/>
        </q-card-actions>
      </q-form>
    </q-card>
  </q-dialog>
</template>

<script>
import {minLength, required, sameAs} from "vuelidate/lib/validators";
import {mapActions} from "vuex";

export default {
  // name: 'ComponentName',
  props: {
    id: {
      type: String,
      default: undefined
    },
    username: {
      type: String,
      default: undefined
    },
    modal: {
      type: Boolean,
      default: false
    },
  },
  validations: {
    changePasswordForm: {
      new_password: {
        required,
        minLength: minLength(8)
      },
      retype_new_password: {
        required,
        sameAsPassword: sameAs('new_password')
      },
    }
  },
  data() {
    return {
      changePasswordForm: {
        new_password: "",
        retype_new_password: "",
      }
    }
  },
  computed: {
    changePasswordModal: {
      get() {
        return this.modal
      },
      set(val) {
        this.$emit('update:modal', val)
      }
    },
    changePasswordId() {
      return this.id;
    },
  },
  methods: {
    ...mapActions("member", ['changePassword']),
    async onChangePassword(e) {
      this.$q.loading.show();
      this.$v.changePasswordForm.$touch();
      try {
        if (!this.$v.changePasswordForm.$invalid) {
          const response = await this.changePassword({
            id: this.changePasswordId,
            new_password: this.changePasswordForm.new_password
          });
          this.modal = false;
          this.$q.loading.hide();
          this.$dialog.alert("เปลี่ยนรหัสผ่านเสร็จสิ้น")
        }
      } catch (ex) {
        this.$q.loading.hide();
        this.modal = false;
        this.$dialog.errorException(ex);
      } finally {
        this.$q.loading.hide();
      }
    },
  }
}
</script>
